function [out] = GearTrain(R)
% GearTrain (4-D) benchmark function, a part of "CFOTool: a MATLAB toolbox
% for Central Force Optimization (CFO)" project
%
% Copyright (C) 2011  Hamed Abdy, Richard A. Formatto, Seyyed Hamid Zahiri
% 
% CFOTool is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% CFOTool is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% MATLAB is a registered trademark of The MathWorks, Inc.
%
% For more information please see "README.txt" file that you recieved with
% this code.
% -------------------------------------------------------------------------
%
% MAXIMUM = 394 at (0,-50)
%
% Reference: "Appendix: A mini-benchmark," Maurice Clerc (NOTE: Uses his notation...)
% -------------------------------------------------------------------------

x1 = round(R(:, 1));
x2 = round(R(:, 2));
x3 = round(R(:, 3));
x4 = round(R(:, 4));

Z = (1 / 6.931 - x1 .* x2 ./ (x3 .* x4)) .^ 2;

out = -Z;
end