function [out] = RosenbrockF6(R)
% Rosenbrock F6 (10-D) benchmark function, a part of "CFOTool: a MATLAB
% toolbox for Central Force Optimization (CFO)" project
%
% Copyright (C) 2011  Hamed Abdy, Richard A. Formatto, Seyyed Hamid Zahiri
% 
% CFOTool is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% CFOTool is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% MATLAB is a registered trademark of The MathWorks, Inc.
%
% For more information please see "README.txt" file that you recieved with
% this code.
% -------------------------------------------------------------------------
%
% WARNING !!  03-19-10  THIS FUNCTION CONTAINS ERRORS.  SEE CLERC's EMAIL!
%
% MAXIMUM = 394 at (0,-50)
%
% Reference: "Appendix: A mini-benchmark," Maurice Clerc (NOTE: Uses his notation...)
% -------------------------------------------------------------------------

[Np, Nd] = size(R);

Xi = R(:, 2:Nd);
Xi1 = R(:, 1:(Nd - 1));

XiOffset = [5, -25, 5, -15, 5, -25, 25, -5, 5, -15];
% XiOffset = [81.0232, -48.3950, 19.2316, -2.5231, 70.4338, 47.1774, -7.8358, -86.6693, 57.8532, 0];
% XiOffset = [80, -50, 20, -3, 70, 47, -8, -87, 58, 0];
% XiOffset = [0, 81.0232, -48.3950, 19.2316, -2.5231, 70.4338, 47.1774, -7.8358, -86.6693, 57.8532];
XiOffset = repmat(XiOffset, Np, 1);

Zi = Xi - XiOffset(:, 2:Nd) + 1;
Zi1 = Xi1 - XiOffset(:, 1:(Nd - 1)) + 1;

Sum1 = sum(100 .* (Zi1 .^ 2 - Zi) .^ 2 + (Zi1 - 1) .^ 2, 2);

Z = 390 + Sum1;

out = -Z;
end

